#################
# K
#################
k = 5

#################
# FUNCTIONS
#################

# upper bound for k scaling x from [0,1/2k] to [0,1]
def f_upper1(x):
	x *= 1/2/k
	a = 2*x/(2^(-k)+x)
	return a

def f_upper2(x):
	x *= 1/2/k
	b = 3/2-sqrt((k+4)/4/k-2*x)
	return b

#################
# SINGLE POINTS 
#################
P = point([0,0],pointsize=120)
P += point([2^(2-k),f_upper2(x=2^(2-k))],pointsize=120)
P += point([1,1], pointsize=120)
P += point([1,1], rgbcolor='white', pointsize=60, zorder = 60)
P += point([1,0.5], pointsize=120)
P += point([1,0.5], rgbcolor='white', pointsize=60, zorder = 60)
P += point([2^(2-k),f_upper1(x=2^(2-k))], pointsize=120, zorder = 55)
P += point([2^(2-k),f_upper1(x=2^(2-k))], rgbcolor='white', pointsize=60, zorder = 60)


#################
# LINES
#################
P += plot( f_upper1, x, 0,2^(2-k), thickness=4)
P += plot( x/2, x, 0, 2^(2-k), fill =f_upper1, fillcolor='gray', fillalpha=0.2, thickness=0)
P += plot( f_upper2, x, 2^(2-k), 1, thickness=4)
P += plot( x/2, x, 2^(2-k), 1, fill =f_upper2, fillcolor='gray', fillalpha=0.2, thickness=0)
P += line([[0,0],[1,0.5]], thickness=4)
P += line([[2^(2-k),f_upper1(x=2^(2-k))],[2^(2-k),f_upper2(x=2^(2-k))]], linestyle='--',  thickness=2, zorder = 50)
P += line([[1.0,0],[1.0,1.0]], linestyle='--', ticks=[[],None] , thickness=2, zorder = 50)




#################
# TEXT 
#################
P += text(r'$(\alpha-1)/k$',(0.15,-0.08), fontsize=20)
P += text(r'$(\alpha-1/2)/k$',(1.1,-0.08), fontsize=20)
P += text(r'$(\nu_0+2)/2k$',(1.2,0.5), fontsize=20)




#################
# ASPECT 
#################
P.axes_labels(['$\\beta$','$d_{F}(\\beta)$'])
P.fontsize(23)
P.set_aspect_ratio(1.1)

#P.show()
P.save('../images/mainspect.png')
